<?php

namespace App\Http\Resources\API;

use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;

class AssetRequirementResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request): array
    {
        return [
            'id' => $this->id,
            'priority' => $this->priority,
            'requirement_group_id' => $this->requirement_group_id ?? 0,
            'requirement_group' => new RequirementGroupParentResource($this->group),
            'title' => $this->title,
            'created_by' => new UserProfileResource($this->createdBy),
            'reviewed_by' =>  new UserProfileResource($this->reviewedBy),
            'plan' => new SimplePlanResource($this->plan),
            'status' => $this->status,
            'asset_id' => $this->asset_id,
            'asset' => new AssetParentResource($this->asset),
            'created_at'=>(string)$this->created_at,
        ];
    }
}
