<?php

namespace App\Http\Resources\API;

use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;

class ContainerDetailResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request): array
    {
        $content = $this->content($request->get("version", 0))->first();

        return [
            'id' => $this->id,
            'name' => $content?->name,
            'library' => new LibrarySimpleResource($this->library),
            'naming_rule' => new NamingRuleSimpleResource($this->namingRule),
            'naming_rules' => $this->naming_rules,
            "mailto"  => $this->mailto,
            "email_subject"  => $this->email_subject,
            "doc_stage"  => $this->doc_stage,
            "doc_type"  => $this->doc_type,
            "description"  => $content?->description ? (new \App\Services\File\ImageUrlService)->getImageUrl($content?->description) : "",
            "acl"  => $this->acl,
            "whitelist"  => make_array_list($this->whitelist??''),
            "version" => $this->version,
            "created_at"  => (string)$this->created_at,
            "created_by" => new UserProfileResource($this->createdBy),
        ];
    }
}
