<?php

namespace App\Services\File\Upload;

use Illuminate\Http\Request;

class FilesUploadService
{
    use FilesUploadTrait;


    protected int $filesSize = 0;

    public function __construct(protected Request $request)
    {
        $this->filesSize = $this->checkRequestData($this->request);

    }

    public function upload(): array
    {
        $items = [];
        $fileNames = $this->request->get("file_names", []);
        foreach ($this->request->file("files") as $index => $file) {

            $item = $this->uploadFile($this->request, $file);
            $item['file']['title'] = $fileNames[$index] ?? $item['file']['title'];

            $items[] = $item;
        }

        $uploadedFiles = $this->storeFiles($items);

        $this->updateUsedStorageCapacity($this->filesSize);

        return $uploadedFiles;
    }
}
