<?php

namespace App\Services\History\Detector;

use App\Services\History\Converter\AssetConverter;
use App\Services\History\Converter\AssetGroupConverter;
use App\Services\History\Converter\ConverterContact;
use App\Services\History\Converter\EmailConverter;
use App\Services\History\Converter\ModelConverter;
use App\Services\History\Converter\ModelEnumConverter;
use App\Services\History\Converter\PlanConverter;
use App\Services\History\Converter\RequirementGroupConverter;
use App\Services\History\Converter\UserConverter;
use App\Services\History\Converter\WhitelistConverter;

class AssetDetector extends DetectorAbstract
{
    public static function fields(): array
    {
        return [
            'name',
            'code',
            'status',
            'address',
            'geo_address_code',
            'latitude',
            'longitude',
            'acl',
            'whitelist',
            'equity_interest',
            'developer',
            'date_completed',
            'total_floor_area',
            'contact_person',
            'contact_phone',
            'contact_email',
            'property',
            'building_type_description',
        ];
    }

    public static function diffFields(): array
    {
        return [
            'description',
        ];
    }

    public static function converters():array
    {
        return [
            "whitelist" => new WhitelistConverter(),
            "status" => new ModelEnumConverter("asset.status"),
            "group_id" => new AssetGroupConverter(),
        ];
    }

    public static function arrayFields(): array
    {
        return [

        ];
    }
}
